{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 2 $  $Modtime: 6/10/09 8:13p $
*       Developer:    brian.juergensmeyer@va.gov
*       Site:         Hines OIFO
*
*       Description:  Image List holder for all forms in CP Flowsheets.
*
*       Notes:        
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/CP Flowsheets/fImageList.pas $
================================================================================
}
unit fImageList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, System.ImageList;

type
  TfrmImageList = class(TForm)
    ilApplicationImages16: TImageList;
    ilApplicationImages32: TImageList;
  private
    { Private declarations }
  public
    { Public declarations }
  end;


const
  BTN_3D_REFRESH = 0;
  BTN_ALIGN_BOTTOMS = 1;
  BTN_ALIGN_LEFT_SIDES = 2;
  BTN_ALIGN_RIGHT_SIDES = 3;
  BTN_ALIGN_TOPS = 4;
  BTN_ALL = 5;
  BTN_ANALYZER = 6;
  BTN_ANALYZER_BW = 7;
  BTN_BINARY = 8;
  BTN_CALCULATOR = 9;
  BTN_CLPBRD = 10;
  BTN_COLLAPSE = 11;
  BTN_DELETE = 12;
  BTN_DROPDOWN = 13;
  BTN_EDIT = 14;
  BTN_EDIT_GS = 15;
  BTN_ERASER = 16;
  BTN_EXPAND = 17;
  BTN_EXPORT = 18;
  BTN_FLDR_CLOSED = 19;
  BTN_FLDR_OPEN = 20;
  BTN_FLOWSHEET = 21;
  BTN_GEAR = 22;
  BTN_GRAPH = 23;
  BTN_GRID_LINES = 24;
  BTN_HELP = 25;
  BTN_HL7 = 26;
  BTN_IMPORT = 27;
  BTN_INCLUDE_TITLE = 28;
  BTN_INFO = 29;
  BTN_INSERT = 30;
  BTN_KEY = 31;
  BTN_LOCKED = 32;
  BTN_MAP = 33;
  BTN_MINUS = 34;
  BTN_MINUS_Z = 35;
  BTN_MOVE_DOWN = 36;
  BTN_MOVE_DOWN_Z = 37;
  BTN_MOVE_LEFT = 38;
  BTN_MOVE_RIGHT = 39;
  BTN_MOVE_UP = 40;
  BTN_MOVE_UP_Z = 41;
  BTN_NAVIGATE_BEGINNING = 42;
  BTN_NAVIGATE_END = 43;
  BTN_NAVIGATE_FIRST = 44;
  BTN_NAVIGATE_LAST = 45;
  BTN_NAVIGATE_NEXT = 46;
  BTN_NAVIGATE_PREV = 47;
  BTN_NEW = 48;
  BTN_OPEN = 49;
  BTN_PENCIL = 50;
  BTN_PERSON = 51;
  BTN_PERSONS = 52;
  BTN_PIVOT = 53;
  BTN_PLUS = 54;
  BTN_PLUS_Z = 55;
  BTN_PRINT = 56;
  BTN_PRINTER = 57;
  BTN_REFRESH = 58;
  BTN_RENAME = 59;
  BTN_RIGHT_BORDER = 60;
  BTN_SAVE = 61;
  BTN_SAVE_ALL = 62;
  BTN_SCANNER = 63;
  BTN_SHOW_3D = 64;
  BTN_SMALL_X = 65;
  BTN_STUDY = 66;
  BTN_SUM = 67;
  BTN_SUM_INACTIVE = 68;
  BTN_THUMB_SHEET = 69;
  BTN_UNDO = 70;
  BTN_VCR_PAUSE = 71;
  BTN_VCR_PLAY = 72;
  BTN_VCR_REWIND = 73;
  BTN_VCR_STOP = 74;
  BTN_VIDEOCAM = 75;
  BTN_VIEW = 76;
  BTN_WEB = 77;
  BTN_WORKING = 78;
  BTN_WRENCH = 79;
  BTN_WWW = 80;
  BTN_X = 81;
  BTN_XML = 82;
  CAL_ACTIVE = 83;
  CAL_INACTIVE = 84;
  EXPAND_NEXT_DAY = 85;
  EXPAND_PREVIOUS_DAY = 86;
  HOLD = 87;
  INFO = 88;
  LV_CALENDAR = 89;
  LV_CHECK_MARK = 90;
  LV_FLOWSHEET_SML = 91;
  LV_FLOWSHEET_SML_BW = 92;
  LV_GATEWAY_SML = 93;
  LV_GROUPER_SML = 94;
  LV_ICON = 95;
  LV_INSTRUMENT_SML = 96;
  LV_LIST = 97;
  LV_MAPPING_SML = 98;
  LV_MAPPING_SML_BW = 99;
  LV_OBS_QUAL_TYPE_SML = 100;
  LV_PARAMETERS_SML = 101;
  LV_PROCEDURE_SML = 102;
  LV_PROCEDURE_SML_BW = 103;
  LV_QUAL_OBS_SML = 104;
  LV_RELOAD = 105;
  LV_REPORT = 106;
  LV_SELECT_ARROW = 107;
  LV_SORT = 108;
  LV_TERM_OBS_SML = 109;
  LV_UNIT_OBS_SML = 110;
  LV_VIEW_SML = 111;
  LV_VIEW_SML_BW = 112;
  SHIFT_ACTIVE = 113;
  SHIFT_INACTIVE = 114;
  TERMINOLOGY_ICON = 115;
  UNHOLD = 116;
  CCOW_NONE = 117;
  CCOW_JOINED = 118;
  CCOW_BROKEN = 119;
  CCOW_CHANGING = 120;
  BTN_WARNING = 121;
  BTN_CAUTION = 122;
  BTN_APPLICATION_COLORS = 123;
  BTN_GREY_CHECK = 124;
  BTN_SETTINGS = 125;

  LV_SORT_FORWARD = 108;
  LV_SORT_REVERSE = 13;

  CCOW_BASE = CCOW_NONE;

  IMAGE_ALARMS_INACTIVE = BTN_CAUTION;
  IMAGE_ALARMS_ACTIVE = BTN_WARNING;

  {
  These arrays are set more for documentation than for anything else.  All of
    the images mentioned below are set at design time.
  }

  USER_OPTIONS_IMAGES: Array [0..3] of integer = (BTN_APPLICATION_COLORS, BTN_PERSON,
    BTN_FLDR_OPEN, BTN_FLDR_CLOSED);

  ALARM_VIEW_IMAGES: Array [0..4] of integer = (BTN_3D_REFRESH, BTN_DELETE, BTN_PENCIL,
    BTN_NEW, BTN_WARNING);

  GRID_VIEW_IMAGES: Array [0..7] of integer = (LV_CALENDAR, EXPAND_PREVIOUS_DAY,
    BTN_NAVIGATE_BEGINNING, BTN_NAVIGATE_END, EXPAND_NEXT_DAY, BTN_NEW, BTN_REFRESH,
    BTN_DELETE);

  HL7_MONITOR_IMAGES: Array [0..7] of integer = (LV_VIEW_SML, BTN_ANALYZER, BTN_PERSON,
    BTN_VCR_PLAY, BTN_DELETE, BTN_3D_REFRESH, LV_PROCEDURE_SML, LV_SORT);

  LOG_VIEW_IMAGES: Array [0..12] of integer = (BTN_GREY_CHECK, BTN_DELETE, BTN_PLUS,
    BTN_MINUS, BTN_REFRESH, LV_CALENDAR, BTN_PRINTER, BTN_PENCIL, LV_SORT, LV_GATEWAY_SML,
    BTN_FLDR_CLOSED, BTN_FLDR_OPEN, LV_PROCEDURE_SML);

  REPORT_VIEW_IMAGES: Array [0..16] of integer = (BTN_GREY_CHECK, BTN_DELETE, BTN_PLUS,
    BTN_MINUS, BTN_REFRESH, LV_CALENDAR, BTN_PRINTER, BTN_PENCIL, LV_SORT, LV_GATEWAY_SML,
    BTN_FLDR_CLOSED, BTN_FLDR_OPEN, LV_PROCEDURE_SML, BTN_NAVIGATE_BEGINNING,
    BTN_NAVIGATE_FIRST, BTN_NAVIGATE_LAST, BTN_NAVIGATE_END);

  TASK_VIEW_IMAGES: Array [0..7] of integer = (BTN_REFRESH, BTN_DELETE, BTN_PENCIL,
    BTN_NEW, BTN_WARNING, LV_CHECK_MARK, UNHOLD, HOLD);

  GRID_FRAME_IMAGES: Array [0..11] of integer = (BTN_DELETE, BTN_SETTINGS, BTN_STUDY,
    BTN_REFRESH, BTN_PRINT, BTN_GRAPH, BTN_EDIT_GS, BTN_ERASER, BTN_NAVIGATE_NEXT,
    BTN_NAVIGATE_PREV, BTN_PIVOT, INFO);

var
  frmImageList: TfrmImageList;

implementation

{$R *.dfm}

end.
