unit fKardexAddEvent;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  oCPTypes,
  oInterfaces, VA508AccessibilityManager, ExtCtrls;

type
  TfrmKardexAddEvent = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    dtpTime: TDateTimePicker;
    dtpDate: TDateTimePicker;
    memComment: TMemo;
    lbxActions: TListBox;
    lblCareActions: TLabel;
    lblDateTimeEventCompleted: TLabel;
    lblComment: TLabel;
    Label3: TLabel;
    chkbxComplete: TCheckBox;
    lbxCompleted: TListBox;
    Label4: TLabel;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    lblLastTime: TVA508StaticText;
    procedure lbxActionsClick(Sender: TObject);
    procedure chkbxCompleteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    function getKardexAction: ICPKardexAction;
    function getDateTime: TDateTime;
    function getComment: string;
  end;

implementation

{$R *.dfm}

uses
  DateUtils;

{ TfrmKardexAddEvent }

procedure TfrmKardexAddEvent.chkbxCompleteClick(Sender: TObject);
begin
  lblDateTimeEventCompleted.Enabled := chkbxComplete.Checked;
  dtpDate.Enabled := chkbxComplete.Checked;
  dtpTime.Enabled := chkbxComplete.Checked;
  memComment.Enabled := chkbxComplete.Checked;
  lblComment.Enabled := chkbxComplete.Checked;
  btnOk.Enabled := chkbxComplete.Checked;
end;

procedure TfrmKardexAddEvent.FormCreate(Sender: TObject);
begin
  dtpDate.DateTime := Now;
  dtpTime.DateTime := Now;
  memComment.Text := '';
  lblLastTime.Caption := '';
  lblLastTime.Font.Style := [fsBold];
end;

function TfrmKardexAddEvent.getKardexAction: ICPKardexAction;
begin
  if lbxActions.ItemIndex > -1 then
    lbxActions.Items.Objects[lbxActions.ItemIndex].GetInterface(ICPKardexAction, Result)
  else
    Result := nil;
end;

function TfrmKardexAddEvent.getComment: string;
begin
  Result := memComment.Text;
end;

function TfrmKardexAddEvent.getDateTime: TDateTime;
begin
  Result := trunc(dtpDate.Date) + frac(dtpTime.Time);
end;

procedure TfrmKardexAddEvent.lbxActionsClick(Sender: TObject);
var
  aAction: ICPKardexAction;
  aEvent: ICPKardexEvent;
  i: integer;
begin
  lbxCompleted.Clear;
  lblLastTime.Caption := '';
  chkbxComplete.Checked := False;
  chkbxComplete.Enabled := False;
  if lbxActions.ItemIndex > -1 then
    if lbxActions.Items.Objects[lbxActions.ItemIndex].GetInterface(ICPKardexAction, aAction) then
      begin
        chkbxComplete.Enabled := True;
        for i := 0 to aAction.getEventCount - 1 do
          if aAction.getEvent(i).QueryInterface(ICPKardexEvent, aEvent) = 0 then
            if aEvent.getStatus = esCompleted then
              lbxCompleted.Items.Add(FormatDateTime('YYYY-MM-DD hh:mm', aEvent.getCompletedDateTime));
        if aAction.getLastCompletedEvent <> nil then
          lblLastTime.Caption := FormatDateTime('YYYY-MM-DD hh:mm', aAction.getLastCompletedEvent.getCompletedDateTime)
        else
          lblLastTime.Caption := 'Never completed';
      end;
end;

end.

