unit fKardexAudits;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  uGlobalVars,
  oInterfaces, VA508AccessibilityManager;

type
  TfrmKardexAudits = class(TForm)
    memLogDisplay: TMemo;
    btnOK: TButton;
    btnPrint: TButton;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
  protected
    fLineNumbers: boolean;
  end;

var
  frmKardexAudits: TfrmKardexAudits;

function DisplayAuditLog(aItem: IInterface; aLog: IInterfaceList; aCaption: string; aPrintOK: boolean = False): TfrmKardexAudits;

implementation

{$R *.dfm}

function DisplayAuditLog(aItem: IInterface; aLog: IInterfaceList; aCaption: string; aPrintOK: boolean = False): TfrmKardexAudits;
var
  i: integer;
  aAudit: ICPKardexAudit;
//  aEvent: ICPKardexEvent;
//  aAction: ICPKardexAction;
  aLine: string;
  aPerson: IPerson;
begin
  Result := TfrmKardexAudits.Create(Application);
  with Result do
    begin
      Caption := aCaption;
      memLogDisplay.Lines.Clear;
      btnPrint.Visible := aPrintOK;

      for i := 0 to aLog.Count - 1 do
        if aLog[i].QueryInterface(ICPKardexAudit, aAudit) = 0 then
          begin
            aPerson := MyPersonService.getPerson(aAudit.getAuditByID);
            aLine := Format(
              '%3d. %s - User: ',
              [i + 1, FormatDateTime('YYYY-MM-DD hh:mm:ss', aAudit.getAuditDateTime)]);
            if Assigned(aPerson) then
              aLine := aLine + Format('(%s)', [aPerson.getInitials])
            else
              aLine := aLine + '*Missing*';
            memLogDisplay.Lines.Add(aLine);
            memLogDisplay.Lines.Add(Format('%16s: %s', ['Description', aAudit.getDescription]));
            memLogDisplay.Lines.Add(Format('%16s: %s', ['Comment', aAudit.getComment]));
            memLogDisplay.Lines.Add('');
          end;
      ShowModal;
    end;
end;

end.

