unit fKardexCustomTimes;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  Buttons, VA508AccessibilityManager;

type
  TfrmKardexCustomTimes = class(TForm)
    Label15: TLabel;
    Label16: TLabel;
    GroupBox4: TGroupBox;
    lblCustomTime: TLabel;
    dtpCustomTime: TDateTimePicker;
    btnCustomTime: TButton;
    lbxDefaultTimes: TListBox;
    lbxScheduledTimes: TListBox;
    btnOK: TButton;
    btnCancel: TButton;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    Memo1: TMemo;
    btnAdd: TBitBtn;
    btnRemove: TBitBtn;
    procedure btnCustomTimeClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnRemoveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function BuildCustomTimes(aOwner: TComponent; var aTimeList: string): boolean;

implementation

{$R *.dfm}

uses
  DateUtils,
  u508Dialogs;

function BuildCustomTimes(aOwner: TComponent; var aTimeList: string): boolean;
var
  i: integer;
begin
  with TfrmKardexCustomTImes.Create(aOwner) do
    try
      lbxDefaultTimes.Items.Clear;
      i := 0;
      while i < 1440 do
        begin
          lbxDefaultTimes.Items.Add(FormatDateTime('hhmm', IncMinute(0, i)));
          inc(i, 30);
        end;
      lbxScheduledTimes.Items.CommaText := aTimeList;
      if ShowModal = mrOK then
        begin
          aTimeList := lbxScheduledTimes.Items.CommaText;
          Result := True;
        end
      else
        Result := False;
    finally
      Free;
    end;
end;

procedure TfrmKardexCustomTimes.btnRemoveClick(Sender: TObject);
begin
  lbxScheduledTimes.DeleteSelected;
end;

procedure TfrmKardexCustomTimes.btnAddClick(Sender: TObject);
begin
  if lbxDefaultTimes.Items.Count > 49 then
    MessageDlg508('Sorry, you are not allowed to customize a schedule with more than 50 times', mtConfirmation, [mbOk], 0)
  else if lbxDefaultTimes.ItemIndex > -1 then
    if lbxScheduledTimes.Items.IndexOf(lbxDefaultTimes.Items[lbxDefaultTimes.ItemIndex]) = -1 then
      lbxScheduledTimes.Items.Add(lbxDefaultTimes.Items[lbxDefaultTimes.ItemIndex])
    else
      MessageDlg508('That time is already assigned.', mtInformation, [mbOk], 0);
end;

procedure TfrmKardexCustomTimes.btnCustomTimeClick(Sender: TObject);
var
  aTime: string;
begin
  if lbxDefaultTimes.Items.Count > 49 then
    MessageDlg508('Sorry, you are not allowed to customize a schedule with more than 50 times', mtConfirmation, [mbOk], 0)
  else
    begin
      aTime := FormatDateTime('hhmm', dtpCustomTime.Time);
      if lbxScheduledTimes.Items.IndexOf(aTime) = -1 then
        lbxScheduledTimes.Items.Add(aTime)
      else
        MessageDlg508('That time is already assigned.', mtInformation, [mbOk], 0);
    end;
end;

end.

