unit fKardexHold;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  StdCtrls,
  ExtCtrls,
  oCPTypes,
  oInterfaces, VA508AccessibilityManager;

type
  TfrmKardexHold = class(TForm)
    btnCancel: TButton;
    btnOK: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    lblHoldDateTime: TLabel;
    dtpDate: TDateTimePicker;
    dtpTime: TDateTimePicker;
    lblComment: TLabel;
    memComment: TMemo;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    lblPrompt: TVA508StaticText;
    procedure memCommentChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function getKardexHoldDateAndComment(aAction: ICPKardexAction; var aHoldDate: TDateTime; var aComment: string): boolean;

implementation

{$R *.dfm}

function getKardexHoldDateAndComment(aAction: ICPKardexAction; var aHoldDate: TDateTime; var aComment: string): boolean;
var
  Y, M, D, hh, mm, ss, ms: Word;
begin
  with TfrmKardexHold.Create(application) do
    try
      dtpDate.Date := trunc(aHoldDate);
      dtpTime.Time := frac(aHoldDate);
      memComment.Text := aComment;
      lblPrompt.Caption := Format('Care Action: %s (%s)',
        [aAction.getCareAction.getDisplayName, aAction.getScheduleDisplay]);
      if aAction.getStatus = asHeld then
        lblHoldDateTime.Caption := 'Effective UnHold Date/Time:'
      else
        lblHoldDateTime.Caption := 'Effective Hold Date/Time:';
      if ShowModal = mrOk then
        begin
          DecodeDate(dtpDate.Date, Y, M, D);
          DecodeTime(dtpTime.Time, hh, mm, ss, ms);
          aHoldDate := EncodeDate(Y, M, D) + EncodeTime(hh, mm, 0, 0);
          aComment := memComment.Text;
          Result := True;
        end
      else
        Result := False;
    finally
      free;
    end;
end;

procedure TfrmKardexHold.FormCreate(Sender: TObject);
begin
  lblPrompt.Font.Style := [fsBold];
end;

procedure TfrmKardexHold.memCommentChange(Sender: TObject);
begin
  btnOK.Enabled := (Length(memComment.Text) > 4);
end;

end.

