unit mHL7Monitor;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  ToolWin,
  StdCtrls,
  ExtCtrls,
  ImgList,
  ActnList,
  XMLDoc,
  XMLIntf,
  oCliO,
  oCliOTypes,
  oInterfaces,
  Buttons,
  uGlobalVars,
  Menus,
  VA508AccessibilityManager,
  fImageList,
  VA508AccessibilityRouter;
//, iCP_View, Menus // zzzzzzandria 2008-07-09
//;

type
  TfraHL7MonitorView = class(TForm, ICPView)
    pnlOptions: TPanel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    tBarGridDateSelector: TToolBar;
    tbtnMatchPatient: TToolButton;
    tbtnMatchInstrument: TToolButton;
    ToolButton3: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    tbtnView: TToolButton;
    ActionList1: TActionList;
    acMatchPatient: TAction;
    acMatchInstrument: TAction;
    acResubmitForProcessing: TAction;
    acDiscard: TAction;
    acViewHL7Message: TAction;
    acOnRefreshFrame: TAction;
    pnlMatchPatient: TPanel;
    edtLookup: TEdit;
    Label1: TLabel;
    lbxPatients: TListBox;
    btnLookup: TButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    acOnLookupPatient: TAction;
    acMatchSelectedPatient: TAction;
    acMatchCancel: TAction;
    acMatchSelectedInstrument: TAction;
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    Shape1: TShape;
    Bevel1: TBevel;
    acOnSelectItem: TAction;
    pgctrl: TPageControl;
    tbshtLog: TTabSheet;
    tbshtHL7: TTabSheet;
    lvHL7Errors: TListView;
    memHL7Text: TMemo;
    acViewLog: TAction;
    Bevel10: TBevel;
    pnlMatchInstrument: TPanel;
    Shape2: TShape;
    Label3: TLabel;
    SpeedButton2: TSpeedButton;
    Label4: TLabel;
    Bevel11: TBevel;
    Bevel12: TBevel;
    lbxInstruments: TListBox;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Label5: TLabel;
    memHL7Errors: TMemo;
    Splitter1: TSplitter;
    ToolButton1: TToolButton;
    pmnView: TPopupMenu;
    Refresh2: TMenuItem;
    GetPatient1: TMenuItem;
    GetInstrument2: TMenuItem;
    ViewHL72: TMenuItem;
    N2: TMenuItem;
    Resubmit2: TMenuItem;
    Discard2: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure acOnRefreshFrameExecute(Sender: TObject);
    procedure acMatchPatientExecute(Sender: TObject);
    procedure acMatchInstrumentExecute(Sender: TObject);
    procedure acResubmitForProcessingExecute(Sender: TObject);
    procedure acDiscardExecute(Sender: TObject);
    procedure acViewHL7MessageExecute(Sender: TObject);
    procedure lbxPatientsDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure acOnLookupPatientExecute(Sender: TObject);
    procedure acMatchSelectedPatientExecute(Sender: TObject);
    procedure acMatchCancelExecute(Sender: TObject);
    procedure acOnSelectItemExecute(Sender: TObject);
    procedure acViewLogExecute(Sender: TObject);
    procedure acMatchSelectedInstrumentExecute(Sender: TObject);
    procedure lvHL7ErrorsColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvHL7ErrorsCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
    procedure lvHL7ErrorsSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvHL7ErrorsKeyPress(Sender: TObject; var Key: Char);
    procedure tbshtLogEnter(Sender: TObject);
    procedure lbxPatientsClick(Sender: TObject);
    procedure lbxInstrumentsClick(Sender: TObject);
  private
    fCliOHL7Log: ICliOHL7Log;
    fCPInstrument: ICPInstrument;
    fPatientMatches: IInterfaceList;
    fSortColumn: integer;

    fMenuItem: TMenuItem;

    procedure ViewInitialize; stdcall;
    procedure ViewActivate; stdcall;
    procedure ViewReload; stdcall;
    procedure ViewDeactivate; stdcall;
    function ViewMenu: TMenuItem; stdcall;
    function ViewHelpContext: integer; stdcall;
  public
    procedure SetInstrumentFilter(aCPInstrument: ICPInstrument);
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

function NewHL7MonitorFrame(aOwner: TWinControl; aCliOHL7Log: ICliOHL7Log): TfraHL7MonitorView;

implementation

uses
  oCPTypes,
  u508Dialogs,
  Math;

{$R *.dfm}

function NewHL7MonitorFrame(aOwner: TWinControl; aCliOHL7Log: ICliOHL7Log): TfraHL7MonitorView;
begin
  Result := TfraHL7MonitorView.Create(aOwner);
  with Result do
    begin
      Parent := aOwner;
      Align := alClient;
      fCliOHL7Log := aCliOHL7Log;
      TInterfaceList.Create.GetInterface(IInterfaceList, fPatientMatches);
      pgctrl.ActivePage := tbshtLog;
      tbshtHL7.TabVisible := False;
      tbshtLog.TabVisible := False;
    end;
end;

procedure TfraHL7MonitorView.acMatchCancelExecute(Sender: TObject);
begin
  pnlMatchPatient.Visible := False;
  pnlMatchInstrument.Visible := False;
  tbtnMatchPatient.Down := False;
  tbtnMatchInstrument.Down := False;
end;

procedure TfraHL7MonitorView.acDiscardExecute(Sender: TObject);
var
  i: integer;
  aMsg: ICliOHL7LogEntry;
begin
  if MessageDlg508('Discard the selected messages?', mtConfirmation, mbYesNo, 0) = mrYes then
    for i := lvHL7Errors.Items.Count - 1 downto 0 do
      if lvHL7Errors.Items[i].Selected then
        begin
          //aMsg := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].Caption);
          //ShowMessageFmt('ID = %s', [lvHL7Errors.Items[i].SubItems[lvHL7Errors.Columns.Count - 1]]);
          aMsg := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].SubItems[lvHL7Errors.Columns.Count - 1]);
          if Assigned(aMsg) then
            begin
              MyCPService.DiscardHL7Message(aMsg.getLogID);
              lvHL7Errors.Items.Delete(i);
            end;
        end;
end;

procedure TfraHL7MonitorView.acMatchInstrumentExecute(Sender: TObject);
begin
  acMatchCancel.Execute;
  lbxInstruments.Items.Clear;
  MyTerminology.LoadTermMappers(lbxInstruments.Items);
  pnlMatchInstrument.Visible := True;
  pnlMatchPatient.Visible := False;
  lbxInstruments.SetFocus;
end;

procedure TfraHL7MonitorView.acMatchPatientExecute(Sender: TObject);
begin
  acMatchCancel.Execute;
  edtLookup.Text := '';
  fPatientMatches.Clear;
  lbxPatients.Items.Clear;
  pnlMatchPatient.Visible := True;
  pnlMatchInstrument.Visible := False;
  edtLookup.SetFocus;
end;

procedure TfraHL7MonitorView.acMatchSelectedInstrumentExecute(Sender: TObject);
var
  i: integer;
  aMappingTable: ITermMapper;
  aMessage: ICliOHL7LogEntry;
begin
  if lbxInstruments.ItemIndex > -1 then
    if lbxInstruments.Items.Objects[lbxInstruments.ItemIndex].GetInterface(ITermMapper, aMappingTable) then
      begin
        if MessageDlg508('Match the selected messages to Mapping Table: ' + #13 + #13 + aMappingTable.getName,
          mtConfirmation, mbYesNo, 0) = mrYes then
          begin
            for i := 0 to lvHL7Errors.Items.Count - 1 do
              if lvHL7Errors.Items[i].Selected then
                begin
                  //aMessage := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].Caption);
                  aMessage := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].SubItems[lvHL7Errors.Columns.Count - 1]);
                  if Assigned(aMessage) then
                    begin
                      MyCPService.MatchHL7MessageToMappingTable(aMessage.getLogID, aMappingTable.getID);
                      aMessage.setMappingTableID(aMappingTable.getID);
                      lvHL7Errors.Items[i].SubItems[2] := aMappingTable.getName;
                    end;
                end;
            acMatchCancel.Execute;
            acViewLog.Execute;
          end;
      end;
end;

procedure TfraHL7MonitorView.acMatchSelectedPatientExecute(Sender: TObject);
var
  i: integer;
  aPatient: IPatient;
  aMessage: ICliOHL7LogEntry;
begin
  if lbxPatients.ItemIndex < 0 then
    exit;
    
  if lbxPatients.Items.Objects[lbxPatients.ItemIndex].GetInterface(IPatient, aPatient) then
    if MessageDlg508('Match the selected messages to patient: ' + #13 + #13 +
      Format('Name: %s' + #13 + 'SSN: %s' + #13 + 'DOB: %s' + #13 + 'Sex: %s',
      [aPatient.getName, aPatient.getSSN, FormatDateTime('m/d/yyyy', aPatient.getDOB), aPatient.getSex]),
      mtConfirmation, mbYesNo, 0) = mrYes then
      begin
        for i := 0 to lvHL7Errors.Items.Count - 1 do
          if lvHL7Errors.Items[i].Selected then
            begin
              aMessage := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].SubItems[lvHL7Errors.Columns.Count - 1]);
              //aMessage := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].Caption);
              if Assigned(aMessage) then
                try
                  MyCPService.MatchHL7MessageToPatient(aMessage.getLogID, aPatient.getDFN);
                  aMessage.setPatient(aPatient);
                  lvHL7Errors.Items[i].SubItems[1] := aMessage.getPatientName;
                except
                  MessageDlg508('Unable to match patient', mtError, [mbOk], 0);
                end;
            end;
        acMatchCancel.Execute;
        acViewLog.Execute;
      end;
end;

procedure TfraHL7MonitorView.acOnLookupPatientExecute(Sender: TObject);
var
  i: integer;
  aPatient: IPatient;
begin
  try
    lbxPatients.Items.BeginUpdate;
    lbxPatients.Items.Clear;
    lbxPatients.ItemHeight := lbxPatients.Canvas.TextHeight('|') * 4;
    MyPatientSource.ExecuteLookupByName(edtLookup.Text, fPatientMatches);
    for i := 0 to fPatientMatches.Count - 1 do
      if fPatientMatches[i].QueryInterface(IPatient, aPatient) = 0 then
        aPatient.AddToList(lbxPatients.Items);
  finally
    lbxPatients.Items.EndUpdate;
  end;
end;

procedure TfraHL7MonitorView.acOnRefreshFrameExecute(Sender: TObject);
var
  aLogEntry: ICliOHL7LogEntry;
begin
  {Note: the id of the message is stored as subitem[columns+1]}
  lvHL7Errors.Items.BeginUpdate;
  lvHL7Errors.Items.Clear;
  lvHL7Errors.Items.EndUpdate;
  Application.ProcessMessages;
  try
    lvHL7Errors.Items.BeginUpdate;
    fPatientMatches.Clear;
    fCliOHL7Log.Refresh;

    aLogEntry := fCliOHL7Log.FirstLogEntry;
    while Assigned(aLogEntry) do
      try
        with lvHL7Errors.Items.Add do
          begin
            Caption := FormatDateTime('YYYY-MM-DD hh:mm:ss', aLogEntry.getMessageDateTime);
            SubItems.Add(aLogEntry.getHL7ErrorText);
            SubItems.Add(aLogEntry.getPatientName);

            if aLogEntry.GetMappingTableID <> '' then
              if Assigned(MyTerminology.GetTermMapper(aLogEntry.getMappingTableID)) then
                SubItems.Add(MyTerminology.GetTermMapper(aLogEntry.getMappingTableID).getName)
              else
                SubItems.Add(Format('No Such Mapping Table (%s)', [aLogEntry.GetMappingTableID]))
            else
              SubItems.Add('No Mapping Table Found');

            SubItems.Add(aLogEntry.getHL7PatientID);
            SubItems.Add(aLogEntry.getHL7DeviceID);
            SubItems.Add(aLogEntry.getLogID);
            ImageIndex := -1;
          end;
      finally
        aLogEntry := fCliOHL7Log.NextLogEntry(aLogEntry);
      end;
  finally
    lvHL7Errors.AlphaSort;
    lvHL7Errors.Items.EndUpdate;
    acViewLog.Execute;
    acOnSelectItem.Execute; {Setup the buttons}
  end;
end;

procedure TfraHL7MonitorView.acOnSelectItemExecute(Sender: TObject);
begin
  acMatchPatient.Enabled := (lvHL7Errors.SelCount > 0) and
     MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR);
  acMatchInstrument.Enabled := (lvHL7Errors.SelCount > 0) and
     MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR);
  acResubmitForProcessing.Enabled := (lvHL7Errors.SelCount > 0) and
     MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR);
  acDiscard.Enabled := (lvHL7Errors.SelCount > 0) and
     MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR);
  acViewHL7Message.Enabled := lvHL7Errors.SelCount = 1;
end;

procedure TfraHL7MonitorView.acResubmitForProcessingExecute(Sender: TObject);
var
  i: integer;
  aMsg: ICliOHL7LogEntry;
begin
  if MessageDlg508('Resubmit the selected messages for processing?', mtConfirmation, mbYesNo, 0) = mrYes then
    for i := lvHL7Errors.Items.Count - 1 downto 0 do
      if lvHL7Errors.Items[i].Selected then
        begin
          aMsg := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].SubItems[lvHL7Errors.Columns.Count - 1]);
          //aMsg := fCliOHL7Log.LogEntry(lvHL7Errors.Items[i].Caption);
          if Assigned(aMsg) then
            begin
              MyCPService.ResubmitHL7Message(aMsg.getLogID);
              lvHL7Errors.Items.Delete(i);
            end;
        end;
end;

procedure TfraHL7MonitorView.acViewHL7MessageExecute(Sender: TObject);
var
  aMessage: ICliOHL7LogEntry;
begin
  if lvHL7Errors.Selected <> nil then
    try
      aMessage := fCliOHL7Log.LogEntry(lvHL7Errors.Selected.SubItems[lvHL7Errors.Columns.Count - 1]);
      //aMessage := fCliOHL7Log.LogEntry(lvHL7Errors.Selected.Caption);
      if Assigned(aMessage) then
        begin
          fCliOHL7Log.LoadMessageText(aMessage, memHL7Text.Lines);
          fCliOHL7Log.LoadMessageErrors(aMessage, memHL7Errors.Lines);
        end;
      pgctrl.ActivePage := tbshtHL7;
      tbtnView.Action := acViewLog;
    except
      on E: Exception do
        MessageDlg508('Error displaying HL7 text.' + #13 + E.Message, mtError, [mbOk], 0);
    end;
end;

procedure TfraHL7MonitorView.acViewLogExecute(Sender: TObject);
begin
  pgctrl.ActivePage := tbshtLog;
  tbtnView.Action := acViewHL7Message;
  {508}
  if ScreenReaderSystemActive and (lvHL7Errors.Items.Count > 0) then
    lvHL7Errors.ItemIndex := 0;
end;

constructor TfraHL7MonitorView.Create(AOwner: TComponent);
var
  Item: TMenuItem;
begin
  inherited;
  FMenuItem := TMenuItem.Create(nil);
  FMenuItem.Caption := 'HL7 Monitor';

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acOnRefreshFrame;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acMatchPatient;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acMatchInstrument;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acViewHL7Message;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Caption := '-';

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acResubmitForProcessing;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acDiscard;
end;

destructor TfraHL7MonitorView.Destroy;
begin
  FreeAndNil(FMenuItem);
  inherited;
end;

procedure TfraHL7MonitorView.lbxInstrumentsClick(Sender: TObject);
begin
  acMatchSelectedInstrument.Enabled := MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR) and
    (lbxInstruments.ItemIndex > -1);
end;

procedure TfraHL7MonitorView.lbxPatientsClick(Sender: TObject);
begin
  acMatchSelectedPatient.Enabled := MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR) and
    (lbxPatients.ItemIndex > -1);
end;

procedure TfraHL7MonitorView.lbxPatientsDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  aPatient: IPatient;
begin
  if lbxPatients.Items.Objects[Index].GetInterface(IPatient, aPatient) then
    with lbxPatients.Canvas do
      begin
        if odSelected in State then
          begin
            Brush.Color := clHighlight;
            Pen.Color := clHighlightText;
            Font.Style := [fsBold];
          end
        else
          begin
            Brush.Color := clWindow;
            Pen.Color := clWindowText;
            Font.Style := [];
          end;
        FillRect(Rect);
        TextOut(Rect.Left + TextWidth('x'), Rect.Top, aPatient.getName);
        TextOut(Rect.Left + TextWidth('xxx'), Rect.Top + (TextHeight('|') * 1),
          'SSN: ' + aPatient.getSSN);
        TextOut(Rect.Left + TextWidth('xxx'), Rect.Top + (TextHeight('|') * 2),
          'DOB: ' + FormatDateTime('m/d/yyyy', aPatient.getDOB));
        TextOut(Rect.Left + TextWidth('xxx'), Rect.Top + (TextHeight('|') * 3),
          'Sex: ' + aPatient.getSex);
      end;
end;

procedure TfraHL7MonitorView.lvHL7ErrorsColumnClick(Sender: TObject; Column: TListColumn);
var
  i: integer;
begin
  fSortColumn := Column.Index;
  for i := 0 to lvHL7Errors.Columns.Count - 1 do
    lvHL7Errors.Columns[i].ImageIndex := -1;
  lvHL7Errors.Columns[fSortColumn].ImageIndex := 7;
  lvHL7Errors.AlphaSort;
end;

procedure TfraHL7MonitorView.lvHL7ErrorsCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
begin
  case fSortColumn of
    0: Compare := AnsiCompareStr(Item1.Caption, Item2.Caption);
  else
    Compare := AnsiCompareStr(Item1.SubItems[fSortColumn - 1], Item2.SubItems[fSortColumn - 1]);
  end;
end;

procedure TfraHL7MonitorView.lvHL7ErrorsKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
    acViewHL7MessageExecute(Sender);
end;

procedure TfraHL7MonitorView.lvHL7ErrorsSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  acOnSelectItemExecute(Sender);
end;

procedure TfraHL7MonitorView.SetInstrumentFilter(aCPInstrument: ICPInstrument);
begin
  fCPInstrument := aCPInstrument;
  acOnRefreshFrame.Execute;
end;

procedure TfraHL7MonitorView.tbshtLogEnter(Sender: TObject);
begin
  lvHL7Errors.SetFocus;
end;

procedure TfraHL7MonitorView.ViewActivate;
begin
  ViewReload;
  Visible := True;
end;

procedure TfraHL7MonitorView.ViewDeactivate;
begin
  Visible := False;
end;

function TfraHL7MonitorView.ViewHelpContext: integer;
begin
  result := HelpContext;
end;

procedure TfraHL7MonitorView.ViewInitialize;
begin
  {
  This needs to be done when an item is selected in the appropriate list view.

  acMatchSelectedInstrument.Enabled := MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR);
  acMatchSelectedPatient.Enabled := MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR);
  }
  acResubmitForProcessing.Enabled := MyUser.HasRole(ROLE_CLIO_HL7_ADMINISTRATOR);
end;

procedure TfraHL7MonitorView.ViewReload;
begin
  acOnRefreshFrame.Execute;
end;

function TfraHL7MonitorView.ViewMenu: TMenuItem; stdcall;
begin
  Result := fMenuItem;
end;

end.

