unit uGlobalVars;

interface

uses
  oCliO,
  oCLiOTypes,
  oInterfaces,
  oDBController_Patient,
  SysUtils,
  Menus,
  Messages,
  VA508AccessibilityManager;

(******************************************************************************)
(*                                                                            *)
(* These are global variables of these interfaces that can be utilized        *)
(* across the entire CP Flowsheets application.                               *)
(*                                                                            *)
(******************************************************************************)

type
  ICPView = interface(IInterface)
    ['{7E72D27E-6175-4A1E-950C-D99016951FE5}']
    procedure ViewInitialize; stdcall;
    procedure ViewActivate; stdcall;
    procedure ViewReload; stdcall;
    procedure ViewDeactivate; stdcall;
    function ViewMenu: TMenuItem; stdcall;
    function ViewHelpContext: integer; stdcall;
  end;

var
  MyUser: IUser;
  MyPatient: IPatient;
  MyVistALogin: IDBConnection;
  MyPatientSource: TDBController_Patient;
  My508Manager: TVA508AccessibilityManager;

  MyCliOService: ICliOService;

  MyTerminology: ITerminology;
  MyPersonService: IPersonService;

  MyCPService: ICPService;
  MyCPKardex: ICPKardexService;

  MyCliOFiler: ICliOFiler;
  MyCliOLoader: ICliOLoader;
  MyCliOList: ICliOList;
  MyCCOWContextor: ICCOWContextor;
  MyApplicationSource: string;
  MyCPParameters: ICPParameters;
  MyUserOptions: ICPUserOptions;
  MyAlarmList: ICliOAlarmList;
  MyStartDateTime: TDateTime;
  MyStopDateTime: TDateTime;

const
  ROLE_CLIO_USER = 'MD USER';
  ROLE_CLIO_MANAGER = 'MD MANAGER';
  ROLE_CLIO_ADMINISTRATOR = 'MD MANAGER';
  ROLE_CLIO_HL7_ADMINISTRATOR = 'MD HL7 MANAGER';
  ROLE_CLIO_READ_ONLY = 'MD READ-ONLY';

  CP_PAGE_FLOWSHEETS = 'Flowsheet';
  CP_PAGE_ALARMS = 'Alarms';
  CP_PAGE_CARE_ACTIONS = 'Tasks';
  CP_PAGE_REPORTS = 'Reports';
  CP_PAGE_LOG_FILES = 'Log Files';
  CP_PAGE_HL7_MONITOR = 'HL7 Monitor';

  FS_CLOSE = WM_APP + 100;
  FS_UPDATE_PERIOD = WM_APP + 101;

implementation


initialization
  My508Manager := nil;
end.

